unit LinkFile;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Registry;

type
  TFormLinkFile = class(TForm)
    LabelCode: TLabel;
    LabelLink: TLabel;
    SBA: TSpeedButton;
    LabelTitle: TLabel;
    LabelA: TLabel;
    SBB: TSpeedButton;
    LabelB: TLabel;
    SBC: TSpeedButton;
    LabelC: TLabel;
    SBD: TSpeedButton;
    LabelD: TLabel;
    SBE: TSpeedButton;
    LabelE: TLabel;
    SBF: TSpeedButton;
    LabelF: TLabel;
    SBG: TSpeedButton;
    LabelG: TLabel;
    SBH: TSpeedButton;
    LabelH: TLabel;
    SBI: TSpeedButton;
    LabelI: TLabel;
    SBJ: TSpeedButton;
    LabelJ: TLabel;
    SBK: TSpeedButton;
    LabelK: TLabel;
    SBL: TSpeedButton;
    LabelL: TLabel;
    SBM: TSpeedButton;
    LabelM: TLabel;
    SBN: TSpeedButton;
    LabelN: TLabel;
    SBO: TSpeedButton;
    LabelO: TLabel;
    SBP: TSpeedButton;
    LabelP: TLabel;
    SBQ: TSpeedButton;
    LabelQ: TLabel;
    SBR: TSpeedButton;
    LabelR: TLabel;
    SBS: TSpeedButton;
    LabelS: TLabel;
    SBT: TSpeedButton;
    LabelT: TLabel;
    SBU: TSpeedButton;
    LabelU: TLabel;
    SBV: TSpeedButton;
    LabelV: TLabel;
    SBW: TSpeedButton;
    LabelW: TLabel;
    SBY: TSpeedButton;
    LabelY: TLabel;
    SBX: TSpeedButton;
    LabelX: TLabel;
    SBZ: TSpeedButton;
    LabelZ: TLabel;
    BBClose: TBitBtn;
    Button1: TButton;
    ExeNameA: TEdit;
    ExeNameB: TEdit;
    ExeNameC: TEdit;
    ExeNameD: TEdit;
    ExeNameE: TEdit;
    ExeNameF: TEdit;
    ExeNameG: TEdit;
    ExeNameH: TEdit;
    ExeNameI: TEdit;
    ExeNameJ: TEdit;
    ExeNameK: TEdit;
    ExeNameL: TEdit;
    ExeNameM: TEdit;
    ExeNameN: TEdit;
    ExeNameO: TEdit;
    ExeNameP: TEdit;
    ExeNameQ: TEdit;
    ExeNameR: TEdit;
    ExeNameS: TEdit;
    ExeNameT: TEdit;
    ExeNameU: TEdit;
    ExeNameV: TEdit;
    ExeNameW: TEdit;
    ExeNameY: TEdit;
    ExeNameX: TEdit;
    ExeNameZ: TEdit;
    SB01: TSpeedButton;
    SB02: TSpeedButton;
    SB03: TSpeedButton;
    SB04: TSpeedButton;
    SB05: TSpeedButton;
    SB06: TSpeedButton;
    SB07: TSpeedButton;
    SB08: TSpeedButton;
    SB09: TSpeedButton;
    SB10: TSpeedButton;
    SB11: TSpeedButton;
    SB12: TSpeedButton;
    SB13: TSpeedButton;
    SB14: TSpeedButton;
    SB15: TSpeedButton;
    SB16: TSpeedButton;
    SB17: TSpeedButton;
    SB18: TSpeedButton;
    SB19: TSpeedButton;
    SB20: TSpeedButton;
    SB21: TSpeedButton;
    SB22: TSpeedButton;
    SB23: TSpeedButton;
    SB25: TSpeedButton;
    SB24: TSpeedButton;
    SB26: TSpeedButton;
    MemoA: TMemo;
    MemoB: TMemo;
    MemoC: TMemo;
    MemoD: TMemo;
    MemoE: TMemo;
    MemoF: TMemo;
    MemoG: TMemo;
    MemoH: TMemo;
    MemoI: TMemo;
    MemoJ: TMemo;
    MemoK: TMemo;
    MemoL: TMemo;
    MemoM: TMemo;
    MemoN: TMemo;
    MemoO: TMemo;
    MemoP: TMemo;
    MemoQ: TMemo;
    MemoR: TMemo;
    MemoS: TMemo;
    MemoT: TMemo;
    MemoU: TMemo;
    MemoV: TMemo;
    MemoW: TMemo;
    MemoX: TMemo;
    MemoY: TMemo;
    MemoZ: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SBAClick(Sender: TObject);
    procedure MemoAEnter(Sender: TObject);
    procedure MemoAExit(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SB01Click(Sender: TObject);
  private
    { Private declarations }
    RKey: String;
  public
    { Public declarations }
  end;

var
  FormLinkFile: TFormLinkFile;

implementation
uses LinkDetail,GetPath;
{$R *.dfm}

procedure TFormLinkFile.FormCreate(Sender: TObject);
var
  I: Integer;
  Reg: TRegistry;
begin
  RKey := 'AutoTransfer';
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    if not Reg.KeyExists(RKey) then
       for I := 1 to 26 do begin
           Reg.OpenKey(RKey,True);
           if not Reg.KeyExists(RKey+'\'+CHR(64+I)) then Reg.CreateKey(Chr(64+I));
           Reg.OpenKey(Chr(64+I),False);
           Reg.WriteString('Title','Function '+CHR(64+I));
           Reg.WriteString('FileName','');
           Reg.CloseKey;
       end;
    for I := 1 to 26 do begin
        Reg.OpenKey(RKey,True);
        if not Reg.KeyExists(RKey+'\'+CHR(64+I)) then Reg.CreateKey(Chr(64+I));
        Reg.OpenKey(Chr(64+I),False);
        TMemo(FindComponent('Memo'+Chr(64+I))).Text := Reg.ReadString('Title');
        TEdit(FindComponent('ExeName'+Chr(64+I))).Text := Reg.ReadString('FileName');
        Reg.CloseKey;
    end;
  finally
    Reg.Free;
  end;
end;

procedure TFormLinkFile.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  I: Integer;
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    for I := 1 to 26 do begin
        Reg.OpenKey(RKey+'\'+Chr(64+I),False);
        Reg.WriteString('Title',TMemo(FindComponent('Memo'+Chr(64+I))).Text);
        Reg.WriteString('FileName',TEdit(FindComponent('ExeName'+Chr(64+I))).Text);
        Reg.CloseKey;
    end;
  finally
    Reg.Free;
  end;
end;

procedure TFormLinkFile.SBAClick(Sender: TObject);
var
  S: String;
begin
  S := '';
  with TEdit(FindComponent('TMemo'+Chr(64+TSpeedButton(Sender).Tag))) do S := Text;
  with TFormGetPath.Create(Self) do
  try
    Caption := S;
    ShowModal;
  finally
    S := Caption;
    Free;
  end;
  if S <> '' then
     with TEdit(FindComponent('TMemo'+Chr(64+TSpeedButton(Sender).Tag))) do Text := S;
end;

procedure TFormLinkFile.MemoAEnter(Sender: TObject);
begin
  with TMemo(Sender) do begin
       Height := 100;
       BringToFront;
  end;
end;

procedure TFormLinkFile.MemoAExit(Sender: TObject);
begin
  with TMemo(Sender) do begin
       Height := 24;
       BringToFront;
  end;
end;

procedure TFormLinkFile.Button1Click(Sender: TObject);
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create(KEY_ALL_ACCESS);
  Reg.RootKey := HKEY_CURRENT_USER;
  Reg.OpenKeyReadOnly(RKey);
  Reg.SaveKey(RKey,'C:\'+RKey);
  Reg.Free;
end;

procedure TFormLinkFile.SB01Click(Sender: TObject);
begin
  with TFormLinkDetail.Create(Self) do
  try
    Caption := RKey+'\'+Chr(64+TSpeedButton(Sender).Tag);
    ShowModal;
  finally
    Free;
  end;
end;

end.
